//
//  DDSViewController.swift
//  DocumentDefaultsSample
//
//  Created by narita on 2019/05/28.
//  Copyright © 2019 narita. All rights reserved.
//

import Cocoa

class DDSViewController: NSViewController
{
    // MARK: - class methods
    
    // MARK: - init methods

    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    // MARK: - action methods
    
    @IBAction func deleteDocDefaultBorderColor(_ sender : Any?)
    {
        documentDefaults?.deleteRecode(name: "BORDER_COLOR")
    }
    
    @IBAction func deleteDocDefaultFillColor(_ sender : Any?)
    {
        documentDefaults?.deleteRecode(name: "FILL_COLOR")
    }

    @IBAction func debug(_ sender : Any?)
    {
        print("theAllRecodes \(documentDefaults?.allRecodes)")
    }

    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods

    // MARK: - accessor methods (in pairs)
    
    @objc class func keyPathsForValuesAffectingWindow() -> Set<String>
    {
        return [ "view", "view.window" ]
    }
    
    @objc open var window: NSWindow?
    {
        return self.view.window
    }
    
    @objc class func keyPathsForValuesAffectingWindowController() -> Set<String>
    {
        return [ "view", "view.window", "view.window.windowController" ]
    }
    
    @objc open var windowController: NSWindowController?
    {
        return self.window?.windowController
    }
    
    @objc class func keyPathsForValuesAffectingDocument() -> Set<String>
    {
        return [ "view", "view.window", "view.window.windowController",
                 "view.window.windowController.document" ]
    }
    
    @objc open var document: NSDocument?
    {
        return self.windowController?.document as! NSDocument?
    }

    @objc class func keyPathsForValuesAffectingDocumentDefaults() -> Set<String>
    {
        return [ "view", "view.window", "view.window.windowController",
                 "view.window.windowController.document", "document" ]
    }
    
    @objc var documentDefaults: MINTLDocumentDefaults?
    {
        return self.document?.value(forKeyPath: "documentDefaults") as? MINTLDocumentDefaults
    }

    // 依存関係を描く
    @objc var canDeleteDocDefaultBorderColor: Bool
    {
        return documentDefaults?.recodeExists(name: "BORDER_COLOR") ?? false
    }
    
    @objc class func keyPathsForValuesAffectingCanDeleteDocDefaultBorderColor() -> Set<String>
    {
        return [ "documentDefaults", "documentDefaults.BORDER_COLOR" ]
    }
    
    @objc var canDeleteDocDefaultFillColor: Bool
    {
        return documentDefaults?.recodeExists(name: "FILL_COLOR") ?? false
    }

    @objc class func keyPathsForValuesAffectingCanDeleteDocDefaultFillColor() -> Set<String>
    {
        return [ "documentDefaults", "documentDefaults.FILL_COLOR" ]
    }
    
    override var representedObject: Any?
    {
        didSet
        {
            // Update the view, if already loaded.
        }
    }
    
    // MARK: - Utility methods
    
}

